package org.orangecloud00.ptmbukkit;

import java.util.HashMap;

import org.bukkit.World;
import org.bukkit.craftbukkit.CraftWorld;
import org.bukkit.generator.ChunkGenerator;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;
import org.orangecloud00.ptmbukkit.generator.ChunkProviderGenerate;
import org.orangecloud00.ptmbukkit.mc173.WorldChunkManager;

public class PTMPlugin extends JavaPlugin
{
	private final HashMap<String, WorldConfig> worldsSettings = new HashMap<String, WorldConfig>();
	private final PTMWorldListener worldListener = new PTMWorldListener(this);

	@Override
	public void onDisable()
	{
		System.out.println(getDescription().getFullName() + " is now disabled");
	}

	@Override
	public void onEnable()
	{
		this.RegisterEvents();
		System.out.println(getDescription().getFullName() + " is now enabled");
	}

	@Override
	public ChunkGenerator getDefaultWorldGenerator(String worldName, String id)
	{
		if (worldsSettings.containsKey(worldName))
		{
			System.out.println("PTM173: enabled for '" + worldName + "'");
			return worldsSettings.get(worldName).ChunkProvider;
		}

		WorldConfig worldSetting = new WorldConfig(this);
		worldsSettings.put(worldName, worldSetting);

		ChunkProviderGenerate prov = new ChunkProviderGenerate(worldSetting);

		System.out.println("PTM173: enabled for '" + worldName + "'");
		return prov;

	}

	public void WorldInit(World world)
	{
		if (this.worldsSettings.containsKey(world.getName()))
		{
			WorldConfig worldSetting = this.worldsSettings.get(world.getName());
			if (worldSetting.isInit)
				return;

			net.minecraft.server.World workWorld = ((CraftWorld) world).getHandle();

			WorldChunkManager wcm = new WorldChunkManager(workWorld.getSeed());
			workWorld.worldProvider.c = wcm;
			worldSetting.ChunkProvider.Init(workWorld, wcm, workWorld.getSeed());
			worldSetting.isInit = true;

			System.out.println("PTM173: world seed is " + workWorld.getSeed());
		}
	}

	private void RegisterEvents()
	{
		PluginManager pm = this.getServer().getPluginManager();
		pm.registerEvents(worldListener, this);
	}	
}
